/*
*****************************************************************************************************
*****************************************************************************************************
*****                                                                                           *****
*****                  Task A   -   Styx movement                                               *****
*****                                                                                           *****
*****************************************************************************************************
*****************************************************************************************************
*/

#include	"styx.h"

#define		STYX_MAX	2
#define		STYX_LINES	8
#define		STYX_SPEED	25

int	x_start[STYX_MAX], y_start[STYX_MAX], x_inc[STYX_MAX], y_inc[STYX_MAX];
int	styx_direction[STYX_MAX];
int	vect_direction[STYX_MAX], v_dir_inc[STYX_MAX], vect_length[STYX_MAX], max_v_length[STYX_MAX];
int	color[STYX_MAX], line_num[STYX_MAX];
int	styx_active;

int	screen_lines[STYX_LINES][STYX_MAX*STYX_LINES];

extern	int	m_x_pos, m_y_pos;

init_ta()
{
	int	a, loop;

	if(get_level()<3)	/* set number of styx creatures on the screen */
		styx_active=1;
	else
		styx_active=2;

	for(a=0; a<styx_active; a++) {	/* initialize all styx positions */

		x_start[a]=80; y_start[a]=30; 
		vect_direction[a]=0; 
		vect_length[a]=10; max_v_length[a]=10;
		for(loop=0; loop<STYX_LINES; loop++) {
			screen_lines[loop][0+a*STYX_LINES]=x_start[a]; 
			screen_lines[loop][1+a*STYX_LINES]=y_start[a]; 
			screen_lines[loop][2+a*STYX_LINES]=x_start[a]; 
			screen_lines[loop][3+a*STYX_LINES]=y_start[a];
			screen_lines[loop][4+a*STYX_LINES]=0;
		}

		line_num[a]=0;
		color[a]=9;		/* get new line color */
		new_dir(a);		/* initialize all other asociated variables */
	}

}



task_a()	/* main styx movement task */
{
 	int	loop;

	if(get_status() )	/* abort routine if man is already dead */
		return(FALSE);

	loop=0;
	while(loop<styx_active) {	/* move all active styx */
		move_styx(loop);
		loop++;
	}

}

move_styx(a)
int	a;	/* styx number a */
{

	int	x1, y1, x2, y2, x_old, y_old, x_length, y_length, colision, retries, loop, temp1, temp2;
		
	retries=3;	/* allow 3 tries to find a good line location */
	while(retries) {

		if(random(get_level()+30)>28)	/* add a random factor for direction change */
			new_dir(a);
		vect_direction[a]+=v_dir_inc[a];	/* increment line vector direction */
		if(vect_direction[a]>=360)		/* check & correct wrap-around */
			vect_direction[a]-=360;
		if(vect_direction[a]<0)
			vect_direction[a]+=360;

		x_length=cosine(vect_direction[a])/vect_length[a];	/* find new X & Y lengths */
		y_length=sine(vect_direction[a])/vect_length[a];

		x_old=x_start[a]; y_old=y_start[a];	/* save origional values incase new ones are NFG */
		x_start[a]+=x_inc[a]; y_start[a]+=y_inc[a];	/* create new vector base location */

		x1=x_start[a]-x_length/2; y1=y_start[a]-y_length/2;	/* make base point for line into centre */
		x2=x_start[a]+x_length/2; y2=y_start[a]+y_length/2;

		/* check the new line for collisions or out of bounds conditions */
		colision=xline(x1,y1,x2,y2,BLACK);

		if(colision & 0x7996 || x_start[a]<0+3 || x_start[a]>159-3 || y_start[a]<8+3 || y_start[a]>99-3) {
			/* line has hit somthing (other than dark cyan, magenta, brown, light blue, green or white */
			x_start[a]=x_old; y_start[a]=y_old;	/* reset origional position values */
			new_dir(a);
			if(vect_length[a]<50)	/* shrink line for an easier fit next try */
				vect_length[a]+=vect_length[a];
			retries--;	/* decrement retries left */
		}
		else {	/* line was OK */
			eline(screen_lines[line_num[a]][0+a*STYX_LINES], screen_lines[line_num[a]][1+a*STYX_LINES],
			     screen_lines[line_num[a]][2+a*STYX_LINES], screen_lines[line_num[a]][3+a*STYX_LINES],
			     screen_lines[line_num[a]][4+a*STYX_LINES]);	/* erase old line */
			screen_lines[line_num[a]][0+a*STYX_LINES]=x1; 	/* update screen-line table values */
			screen_lines[line_num[a]][1+a*STYX_LINES]=y1; 
			screen_lines[line_num[a]][2+a*STYX_LINES]=x2; 
			screen_lines[line_num[a]][3+a*STYX_LINES]=y2;
			screen_lines[line_num[a]][4+a*STYX_LINES]=color[a];
			line(x1,y1,x2,y2,screen_lines[line_num[a]][4+a*STYX_LINES]);	/* draw new line on screen */

			line_num[a]++;	/* increment present line pointer */
			if(line_num[a]>=STYX_LINES) {	/* check & correct wrap-around */
				line_num[a]=0;
				switch(random(4)) {	/* get new line color */
				case 0:
					color[a]=DARK_CYAN;
					break;
				case 1:
					color[a]=DARK_MAGENTA;
					break;
				case 2:
					color[a]=DARK_BROWN;
					break;
				case 3:
					color[a]=LIGHT_BLUE;
					break;
				case 4:
					color[a]=LIGHT_GREEN;
					break;
				}

			}

			if(vect_length[a]>10)	/* if line is very small then lengthen it imediately */
				vect_length[a]=10;
			if(vect_length[a]>max_v_length[a])	/* if line is smaller than its maximum then lengthen it */
				vect_length[a]--;
			if(vect_length[a]<max_v_length[a])	/* if line is longer than its maximum then shorten it */
				vect_length[a]++;

			retries=0;	/* reset retries as a line has been generated */
			if(a==0) {	/* set tone for styx sound - varies with mans distence from styx[0] */
				temp1=abs(x_start[0]-m_x_pos);
				temp2=abs(y_start[0]-m_y_pos);
				temp1+=temp2;								
				snd_styx(temp1);
			}
			if(colision & 0x8000) /* line has hit styx trail */
				make_dead(STYX);


		}

	}	

}



	/* change all variables to create a new heading & line size */
new_dir(a)
int	a;	/* styx number */
{
	int	temp;

	styx_direction[a]=random(89)*4;	/* get new direction of travel for base point of styx */

	max_v_length[a]=random(3)+3;	/* get new maximum line vector length */
	if(styx_active==2)	/* shorten styx if two are present */
		max_v_length[a]+=5;
	/* calculate X & Y movement offsets from vector values */
	if(get_level()>5)	/* get speed variation limit */
		temp=5;
	else
		temp=get_level();
	x_inc[a]=cosine(styx_direction[a])/(STYX_SPEED-random(12+temp));
	y_inc[a]=sine(styx_direction[a])/(STYX_SPEED-random(10+temp));
	v_dir_inc[a]=random(15)+5;	/* get new vector rotation increment */
	if(random(1))			/* make vector rotation CW or CCW */
		v_dir_inc[a]=-v_dir_inc[a];

}



check_styx()	/* used after a fill to find if styx[1] is still active */
{

	if(styx_active==2) {
		if(!(xpset(x_start[1],y_start[1],BLACK) & 0x0001))
			styx_active=1;
	}

}



draw_styx()
{	/* re-draw all styx that are on screen.  Needed when fill destroys styx in memory buffer */
	int	colision, loop, a, lnum;

	a=0;
	while(a<styx_active) {
		lnum=line_num[a];
		for(loop=0; loop<STYX_LINES; loop++) {
			colision=xline(screen_lines[lnum][0+a*STYX_LINES], screen_lines[lnum][1+a*STYX_LINES],
			      screen_lines[lnum][2+a*STYX_LINES], screen_lines[lnum][3+a*STYX_LINES],
			      BLACK );	/* check line locations */
			if(colision & 0xf996) {	/* erase any styx that are in the filled area or on a line */
				a=a;	/* dummy line for non debug version */
#ifdef DEBUG
				cprintf("styx line was in filled area - not redrawn \n\r");
#endif

			}
			else	/* draw styx line at new location */
				line(screen_lines[lnum][0+a*STYX_LINES], screen_lines[lnum][1+a*STYX_LINES],
			             screen_lines[lnum][2+a*STYX_LINES], screen_lines[lnum][3+a*STYX_LINES],
			             screen_lines[lnum][4+a*STYX_LINES]);	/* draw line */

			lnum++;
			if(lnum>=STYX_LINES)
				lnum=0;
		}
		a++;
	}
}


era_styx()
{	/* erase all styx that are on screen.  Needed when filling screen with new color */
	int	colision, loop, a, lnum;

	screen=FALSE;	/* erase styx only in memory buffer */
	a=0;
	while(a<styx_active) {
		lnum=line_num[a];
		for(loop=0; loop<STYX_LINES; loop++) {
			eline(screen_lines[lnum][0+a*STYX_LINES], screen_lines[lnum][1+a*STYX_LINES],
		             screen_lines[lnum][2+a*STYX_LINES], screen_lines[lnum][3+a*STYX_LINES],
		             screen_lines[lnum][4+a*STYX_LINES]);	/* erase line */

			lnum++;
			if(lnum>=STYX_LINES)
				lnum=0;
		}
		a++;
	}
	screen=TRUE;
}


get_styx()
{
	return(styx_active);

}

