/*
*****************************************************************************************************
*****************************************************************************************************
*****                                                                                           *****
*****                  Task F   -   Score & Screen Updating                                     *****
*****                                                                                           *****
*****                                                                                           *****
*****************************************************************************************************
*****************************************************************************************************
*/

#include	"styx.h"
extern	char	diskdata[];	/* external disk transfer buffer */

long	score_p, score_o, score_h;

int	old_filled, filled, score_mult, score_cycle, timeout;

char	htemp[10], highscore[40];

long	score[11];

char	name[11][4]	= { "...", "...", "...", "...", "...", "...", "...", "...", "...", "...", "..." };

/* ********************************************************************* */
/*	arrays for score_mult display */
/* ********************************************************************* */


char	mult2_image[] = {	9,7,
				0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,
				0x11,0x11,0x01,0x11,0x01,0x11,0x01,0x11,0x11,
				0x11,0x11,0x10,0x10,0x11,0x10,0x01,0x11,0x11,
				0x11,0x11,0x11,0x01,0x11,0x11,0x01,0x11,0x11,
				0x11,0x11,0x10,0x10,0x11,0x11,0x01,0x11,0x11,
				0x11,0x11,0x01,0x11,0x01,0x10,0x00,0x11,0x11,
				0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11 };


char	mult3_image[] = {	9,7,
				0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,
				0x44,0x44,0x04,0x44,0x04,0x40,0x00,0x44,0x44,
				0x44,0x44,0x40,0x40,0x44,0x40,0x44,0x44,0x44,
				0x44,0x44,0x44,0x04,0x44,0x40,0x00,0x44,0x44,
				0x44,0x44,0x40,0x40,0x44,0x44,0x40,0x44,0x44,
				0x44,0x44,0x04,0x44,0x04,0x40,0x00,0x44,0x44,
				0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44,0x44 };


char	mult5_image[] = {	9,7,
				0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x22,
				0x22,0x02,0x22,0x02,0x22,0x02,0x20,0x00,0x22,
				0x22,0x20,0x20,0x22,0x22,0x02,0x20,0x20,0x22,
				0x22,0x22,0x02,0x22,0x22,0x02,0x20,0x20,0x22,
				0x22,0x20,0x20,0x22,0x22,0x02,0x20,0x20,0x22,
				0x22,0x02,0x22,0x02,0x22,0x02,0x20,0x00,0x22,
				0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x22,0x22 };



char	ps_image[] = {		3,5,
				0x0f,0x00,0x0f,
				0x00,0x00,0xf0,
				0x00,0x0f,0x00,
				0x00,0xf0,0x00,
				0x0f,0x00,0x0f };



init_tf()	/* reset scores related to the present game - not high scores */
{
	filled=0; old_filled=filled; score_mult=2; score_cycle=15;
	make_f_color(DARK_BLUE);
	print_present_score();	/* show the score on screen */
}


                             

init_hi_score()
{	/* reset high score */
	int	temp, count, loop, loop2;

	score_h=0;

	getbuf();	/* get track 39, sector #1 of drive 0 */

	count=1;	/* recover high scores from disk buffer */
	for(loop=1; loop<11; loop++) {

		for(loop2=0; loop2<3; loop2++) {	/* get 3 character name */
			name[loop][loop2]=diskdata[count];
			count++;
		}

		count+=2;	/* disgard padding of 2 spaces */

		for(loop2=0; loop2<6; loop2++) {	/* get 6 digit score */
			htemp[loop2]=diskdata[count];
			count++;
		}

		strnum(htemp,&score[loop]);	/* convert 6 digit score string to la long int */

	}

	if(diskdata[0]!='s') { /* reset all scores if read was not good */
		for(temp=0; temp<11; temp++) {
			score[temp]=0;
			strcpy(name[temp],"...");
		}
	}

}



rst_score()	/* reset scores for this game */
{
	score_p=0; score_o=0; 

}



task_f()	/* update fill multiplyer */
{

	score_cycle--;
	if(!score_cycle) {
		switch(score_mult) {
		case 2:
			score_cycle=12;	/* delay before next change of multiplyer */
			score_mult=3;	/* new score multiplyer */
			make_f_color(DARK_RED);	/* new color */
			break;
		case 3:
			score_cycle=8;
			score_mult=5;
			make_f_color(DARK_GREEN);
			break;
		case 5:
			score_cycle=18;
			score_mult=2;
			make_f_color(DARK_BLUE);
			break;
		default:
			break;
		}
	
        	draw_mult();	/* show new multiplyer on screen */

	}

}



make_filled(val)	/* called during a fill to update filled score */
int	val;
{
	filled=val;	/* update filled value */
	switch(score_mult) {
	case 2:
		score_p+=(filled-old_filled); 	/* add new score */
		break;
	case 3:
		score_p+=((filled-old_filled)*5); 	/* add new score */
		break;
	case 5:
		score_p+=((filled-old_filled)*10); 	/* add new score */
		break;
	}

	if(score_p>999999) 	/* check score for roll over */
		score_p=0;

	old_filled=filled;	/* save value for comparison next time */
	if(filled>=800)	/* check if the screen is past 80% full */
		make_full(TRUE);
	print_present_score();	/* update score on screen */

}



draw_mult()	/* draw the score multiplyer on the screen */
{
	switch(score_mult) {
	case 2:
		putf(138,1,mult2_image);
		break;
	case 3:
		putf(138,1,mult3_image);
		break;
	case 5:
		putf(138,1,mult5_image);
		break;
	default:
		break;
	}
}



check_hi_score()
{	/* update score display & check for high score */
	int	loop, xloop, yloop;

	print_present_score();	/* update score display */

	if(score_p>score[10]) {	/* a new high score has been reached */
		
		text_color(LIGHT_CYAN);

		write_text("NEW HIGH SCORE",10,20);	/* write high score on screen */
		line(10,19,149,19,BLACK);
		line(10,27,149,27,BLACK);

		empty_screen();	/* clear the memory buffer */

		write_text("NEW HIGH SCORE",10,20);	/* rewrite high score on memory buffer */

		retscn();	/* move memory buffer to screen */

		get_name();	/* get initiales for this player */

		sort_scores();	/* update high score list */

		save_scores();	/* save high scores on disk */
	}
	else {	/* display game over message if not a new high score */
		for(loop=43; loop<54; loop++)
			line(30,loop,127,loop,BLACK);	/* clear area */
		line(30,42,127,42,DARK_WHITE);
		line(127,42,127,54,DARK_WHITE);
		line(127,54,30,54,DARK_WHITE);
		line(30,54,30,42,DARK_WHITE);

		text_color(DARK_WHITE);
		for(loop=1; loop<30; loop++) {
			flash_game_over(loop); 	/* change letter color */
			write_text("GAME OVER",34,45);
		}
		text_color(LIGHT_CYAN);
		write_text("GAME OVER",34,45);
		sleep(200);
	}

	
}


check_bonus()
{	/* award 1000 points for eack 1% over 80%  */
	long	l_temp;
	int	temp, y;

	temp=filled/10-80;
	if(temp<1)
		temp=0;
	temp*=1000;	/* multiply by 1000 for bonus */
	score_p+=temp;
	if(temp) {
		l_temp=temp;	/* get the long equivelent */
		strcpy(htemp,"");	/* empty string */
		strscr(htemp,l_temp,FALSE);	/* get ascii string for bonus */
        	temp=strlen(htemp);
		text_color(LIGHT_CYAN);
		write_text("       ",45,38);
		write_text(" BONUS ",45,45);
		write_text("       ",45,52);
		write_text("       ",45,59);
		write_text(htemp,80-temp*5,59);
		write_text("       ",45,66);
	}
}



print_present_score()
{	/* display present score, number of lives left & high score if one has been set */
	print_score(score_p,1,2);		/* print present score at top left of screen */
	print_lives();		/* print men at the top of screen to indicate spare lives */
	draw_mult();		/* show score multiplyer */
	print_filled();

}



print_score(amount,pos,ypos)	/* print a score at a position on the top line */
long	amount;
int	pos, ypos;       
{

	int	chr, offset;
	long	digit;

	offset=0; digit=100000;

	while(digit>1) {	/* print all digits seperately exept the last */
		chr=amount/digit;
		amount %=digit;
		if(chr || digit!=100000)
			write_num(chr,pos+offset,ypos);
		digit /=10; offset++;
	}

	chr=amount;	/* print the last digit */
	write_num(chr,pos+5,ypos);

}



print_lives()
{	/* draw guns on the top line to show spare lives */
 	int	loop, temp;

	temp=get_lives()-1;	/* dont show present life */
	for(loop=1; loop<5; loop++) {	/* a maximum of 4 lives may be displayed */

		if(temp>0)	/* draw gun */
			write_man(loop);
		else
			write_blank(loop);	/* draw a blank to cover any posible gun in that spot */

		temp--;
	}

}



print_filled()	/* show the % filled on screen */
{
	int	pos, chr, offset, digit, amount;

	pos=26; amount=filled;

	offset=0; digit=100;

	while(digit>1) {	/* print all digits seperately exept the last */
		chr=amount/digit;
		amount %=digit;
		if(chr || digit==10)
			write_num(chr,pos+offset,2);
		digit /=10; offset++;
	}

	chr=amount;	/* print the last digit */
	write_num(chr,pos+3,2);

	pset(114,6,LIGHT_WHITE);	/* decimal point */

	putf(123,2,ps_image);		/* % sign */

}


show_scores()	/* display high score list */
{
	int	loop, color;

	ttyrst(1,26);	/* set cursor */
	col_print("HIGH SCORES",3);
	color=2;
	for(loop=1; loop<11; loop++) {
		strcpy(highscore,"");	/* empty string */
		strcat(highscore,name[loop]);
		strcat(highscore,"  ");
		strscr(htemp,score[loop],TRUE);	/* get ascii string for score value */
		strcat(highscore,htemp);
		ttyrst(2+loop,26);
		col_print(highscore,color);
		color=1;
	}

}




save_scores()	/* save scores to disk buffer */
{
	int	loop, temp;

	strcpy(diskdata,"s");	/* clear buffer & show good data with s as the first character */


	for(loop=1; loop<11; loop++) {
		strcpy(highscore,"");	/* empty string */
		strcat(highscore,name[loop]);
		strcat(highscore,"  ");
		strscr(htemp,score[loop],TRUE);	/* get ascii string for score value */
		strcat(highscore,htemp);
		strcat(diskdata,highscore);
	}
	savbuf();	/* save to disk */ 

}




	

get_name()	/* get players initials from the keyboard */
{
	int	y, temp, count;

	text_color(DARK_WHITE);
	write_text("ENTER YOUR",30,50);
	write_text("INITIALS",40,60);

	text_color(LIGHT_WHITE);
	write_text("_ _ _",55,80);

	strcpy(name[0],"...");
	timeout=FALSE;
	for(count=0; count<3; count++) {

		temp=0;
		while(temp==0 && !timeout) {
			temp=getkey(55+count*20,80);
			if(count && temp==0xe)
				count--;
			temp=conkey(temp);
		}

		if(temp!=0) {
			write_char(temp,55+count*20,80);
			name[0][count]=temp;	/* store ascii in string */
		}

	}
	keychr=0;

}



getkey(x,y)	/* get a letter from the keybaord & flash cursor */
int	x, y;
{
	int	count, loop;

	keychr=0;

	for(loop=0; loop<50; loop++) {
		write_char('_',x,y);
		for(count=0; count<30; count++) {
			if(!(keychr & 0x80) && keychr)
				return(keychr);
			sleep(5);
		}
		write_char(' ',x,y);
		for(count=0; count<50; count++) {
			if(!(keychr & 0x80) && keychr) {
				write_char('_',x,y);
				return(keychr);
			}
			sleep(5);
		}
	}
	timeout=TRUE;	/* dont wait for ever */
	return(0);
}



sort_scores()	/* sort new score into the top 10 list */
{
        int	loop, count;


	count=10;
	while(count>1)  {	/* locate position of new score */
		if(score_p>=score[count-1])
			count--;
		else {
			break;
		}
	}

	for(loop=10; loop>count; loop--) {
		score[loop]=score[loop-1];
		strcpy(name[loop],name[loop-1]);
	}

	score[count]=score_p;
	strcpy(name[count],name[0]);


}




strscr(out,amount,blanks)	/* convert a long integer to a string  */
char	out[];
long	amount;
int	blanks;	/* if set to true a blank is inserted for leading zero's */
{

	int	chr, offset, flag;
	long	digit, testval;
	char	tstr[10];

	offset=0; digit=100000; flag=FALSE;
	strcpy(out,"");	/* initialize output string */

	while(digit>1) {	/* print all digits seperately exept the last */
		chr=amount/digit;
		amount %=digit;
		stcu_d(tstr,chr,10);	/* get ascii into tstr */
		if(chr || flag)	{ 	/* dont use leading zero's */
			strcat(out,tstr);	/* put new ascii digit on end of string */
			flag=TRUE;	/* show end of leading zero's */
		}
		else
			if(blanks)
				strcat(out," ");	/* replace leading zero's with a blank */

		digit /=10; offset++;
	}

	chr=amount;	/* print the last digit */
	stcu_d(tstr,chr,10);	/* get ascii into tstr */
	strcat(out,tstr);	/* put new ascii digit on end of string */


}


strnum(instr,amount)	/* convert a 6 digit string to a long integer  */
char	instr[];
long	*amount;
{

	int	chr, offset, flag;
	long	digit;

	offset=0; digit=100000; *amount=0;

	while(digit>0) {	/* print all digits seperately exept the last */
		chr=getval(instr[offset]);
		*amount =*amount+(digit*chr);
		digit /=10; offset++;
	}

}



get_mult()
{

	return(score_mult);

}

