/*
***************************************************************************************************
***************************************************************************************************
**                                                                                               **
**                                        S T Y X                                                **
**                                                                                               **
**                              D a t a    D e f i n i t i o n s                                 **
**                                                                                               **
**                                                                                               **
***************************************************************************************************
***************************************************************************************************
*/

#include "styx.h"


/* *************************************************************************** */
/*	arrays used for message and character generation */
/* *************************************************************************** */



	/* character definitions for small number write routine */

char chr_sp[] = {		2,5,
				0x00,0x00,
				0x00,0x00,
				0x00,0x00,
				0x00,0x00,
				0x00,0x00 };
				
				
char chr_0[] = {		2,5,
				0x0f,0xff,
				0x0f,0x0f,
				0x0f,0x0f,
				0x0f,0x0f,
				0x0f,0xff };

char chr_1[] = {		2,5,
				0x00,0xf0,
				0x00,0xf0,
				0x00,0xf0,
				0x00,0xf0,
				0x00,0xf0 };

char chr_2[] = {		2,5,
				0x0f,0xff,
				0x00,0x0f,
				0x0f,0xff,
				0x0f,0x00,
				0x0f,0xff };

char chr_3[] = {		2,5,
				0x0f,0xff,
				0x00,0x0f,
				0x00,0xff,
				0x00,0x0f,
				0x0f,0xff };

char chr_4[] = {		2,5,
				0x0f,0x00,
				0x0f,0x0f,
				0x0f,0xff,
				0x00,0x0f,
				0x00,0x0f };

char chr_5[] = {		2,5,
				0x0f,0xff,
				0x0f,0x00,
				0x0f,0xff,
				0x00,0x0f,
				0x0f,0xff };

char chr_6[] = {		2,5,
				0x0f,0xff,
				0x0f,0x00,
				0x0f,0xff,
				0x0f,0x0f,
				0x0f,0xff };

char chr_7[] = {		2,5,
				0x0f,0xff,
				0x00,0x0f,
				0x00,0x0f,
				0x00,0x0f,
				0x00,0x0f };

char chr_8[] = {		2,5,
				0x0f,0xff,
				0x0f,0x0f,
				0x0f,0xff,
				0x0f,0x0f,
				0x0f,0xff };

char chr_9[] = {		2,5,
				0x0f,0xff,
				0x0f,0x0f,
				0x0f,0xff,
				0x00,0x0f,
				0x00,0x0f };


/*

	/* HI SCORE message definition used by write_high_score() */

char text_high_score[] = {	16,5,
				0x40,0x40,0x44,0x40,0x00,0x00,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,0x44,0x40,
				0x40,0x40,0x04,0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x00,
				0x44,0x40,0x04,0x00,0x00,0x00,0x44,0x40,0x40,0x00,0x40,0x40,0x44,0x40,0x44,0x40,
				0x40,0x40,0x04,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x40,0x40,0x44,0x00,0x40,0x00,
				0x40,0x40,0x44,0x40,0x00,0x00,0x44,0x40,0x44,0x40,0x44,0x40,0x40,0x40,0x44,0x40 };

*/


	/* character definitions for write_char() large text writing routine */

char char_a [] = {		5,7,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x0f,0x0f,0x00,0,
				0x00,0xf0,0x00,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0xff,0xff,0xff,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0 };

char char_b [] = {		5,7,
				0x0f,0xff,0xff,0xf0,0,
				0x00,0xf0,0x00,0x0f,0,
				0x00,0xf0,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0,
				0x00,0xf0,0x00,0x0f,0,
				0x00,0xf0,0x00,0x0f,0,
				0x0f,0xff,0xff,0xf0,0 };

char char_c [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_d [] = {		5,7,
				0x0f,0xff,0xff,0xf0,0,
				0x00,0xf0,0x00,0x0f,0,
				0x00,0xf0,0x00,0x0f,0,
				0x00,0xf0,0x00,0x0f,0,
				0x00,0xf0,0x00,0x0f,0,
				0x00,0xf0,0x00,0x0f,0,
				0x0f,0xff,0xff,0xf0,0 };

char char_e [] = {		5,7,
				0x0f,0xff,0xff,0xff,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0xff,0xff,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0xff,0xff,0xff,0 };

char char_f [] = {		5,7,
				0x0f,0xff,0xff,0xff,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0xff,0xff,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0 };

char char_g [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x0f,0xff,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_h [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0xff,0xff,0xff,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0 };

char char_i [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0xff,0xff,0xf0,0 };

char char_j [] = {		5,7,
				0x00,0x00,0x0f,0xff,0,
				0x00,0x00,0x00,0xf0,0,
				0x00,0x00,0x00,0xf0,0,
				0x00,0x00,0x00,0xf0,0,
				0x0f,0x00,0x00,0xf0,0,
				0x00,0xf0,0x00,0xf0,0,
				0x00,0x0f,0xff,0x00,0 };

char char_k [] = {		5,7,
				0x0f,0x00,0x00,0xf0,0,
				0x0f,0x00,0xf0,0x00,0,
				0x0f,0xf0,0x00,0x00,0,
				0x0f,0x0f,0x00,0x00,0,
				0x0f,0x00,0xf0,0x00,0,
				0x0f,0x00,0x0f,0x00,0,
				0x0f,0x00,0x00,0xf0,0 };

char char_l [] = {		5,7,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0xff,0xff,0xff,0 };

char char_m [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0xf0,0x00,0xff,0,
				0x0f,0x0f,0x0f,0x0f,0,
				0x0f,0x00,0xf0,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0 };

char char_n [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0xf0,0x00,0x0f,0,
				0x0f,0x0f,0x00,0x0f,0,
				0x0f,0x00,0xf0,0x0f,0,
				0x0f,0x00,0x0f,0x0f,0,
				0x0f,0x00,0x00,0xff,0,
				0x0f,0x00,0x00,0x0f,0 };

char char_o [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_p [] = {		5,7,
				0x0f,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0 };

char char_q [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x0f,0x0f,0,
				0x0f,0x00,0x00,0xff,0,
				0x00,0xff,0xff,0xf0,0 };

char char_r [] = {		5,7,
				0x0f,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0xff,0xff,0xf0,0,
				0x0f,0x00,0x0f,0x00,0,
				0x0f,0x00,0x00,0xf0,0,
				0x0f,0x00,0x00,0x0f,0 };

char char_s [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x00,0,
				0x00,0xff,0xff,0xf0,0,
				0x00,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_t [] = {		5,7,
				0x0f,0xff,0xff,0xff,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0 };

char char_u [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_v [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xf0,0x00,0xf0,0,
				0x00,0x0f,0x0f,0x00,0,
				0x00,0x00,0xf0,0x00,0 };

char char_w [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0xf0,0x0f,0,
				0x0f,0x00,0xf0,0x0f,0,
				0x0f,0x0f,0x0f,0x0f,0,
				0x00,0xf0,0x00,0xf0,0 };

char char_x [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xf0,0x00,0xf0,0,
				0x00,0x0f,0x0f,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x0f,0x0f,0x00,0,
				0x00,0xf0,0x00,0xf0,0,
				0x0f,0x00,0x00,0x0f,0 };

char char_y [] = {		5,7,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xf0,0x00,0xf0,0,
				0x00,0x0f,0x0f,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0 };

char char_z [] = {		5,7,
				0x0f,0xff,0xff,0xff,0,
				0x00,0x00,0x00,0xf0,0,
				0x00,0x00,0x0f,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x0f,0x00,0x00,0,
				0x00,0xf0,0x00,0x00,0,
				0x0f,0xff,0xff,0xff,0 };

char char_space [] = {		5,7,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0 };

char char_dot [] = {		5,7,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0x00,0x00,0 };

char char_bar [] = {		5,7,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0x00,0x00,0x00,0,
				0x00,0xff,0xff,0xf0,0,
				0x00,0x00,0x00,0x00,0 };

char char_0 [] = {		5,7,
				0x00,0x0f,0xff,0x00,0,
				0x00,0xf0,0x00,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xf0,0x00,0xf0,0,
				0x00,0x0f,0xff,0x00,0 };

char char_1 [] = {		5,7,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x0f,0xf0,0x00,0,
				0x00,0xf0,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0xff,0xff,0xf0,0 };

char char_2 [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0x00,0x00,0x0f,0,
				0x00,0x00,0x0f,0xf0,0,
				0x00,0x0f,0xf0,0x00,0,
				0x00,0xf0,0x00,0x00,0,
				0x0f,0xff,0xff,0xff,0 };

char char_3 [] = {		5,7,
				0x0f,0xff,0xff,0xff,0,
				0x00,0x00,0x00,0xf0,0,
				0x00,0x00,0x0f,0x00,0,
				0x00,0x00,0xff,0xf0,0,
				0x00,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_4 [] = {		5,7,
				0x00,0x00,0x0f,0xf0,0,
				0x00,0x00,0xf0,0xf0,0,
				0x00,0x0f,0x00,0xf0,0,
				0x00,0xf0,0x00,0xf0,0,
				0x0f,0xff,0xff,0xff,0,
				0x00,0x00,0x00,0xf0,0,
				0x00,0x00,0x00,0xf0,0 };

char char_5 [] = {		5,7,
				0x0f,0xff,0xff,0xff,0,
				0x0f,0x00,0x00,0x00,0,
				0x0f,0xff,0xff,0xf0,0,
				0x00,0x00,0x00,0x0f,0,
				0x00,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_6 [] = {		5,7,
				0x00,0x00,0x0f,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x0f,0x00,0x00,0,
				0x00,0xf0,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_7 [] = {		5,7,
				0x0f,0xff,0xff,0xff,0,
				0x00,0x00,0x00,0xf0,0,
				0x00,0x00,0x0f,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x0f,0x00,0x00,0,
				0x00,0xf0,0x00,0x00,0,
				0x0f,0x00,0x00,0x00,0 };

char char_8 [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0 };

char char_9 [] = {		5,7,
				0x00,0xff,0xff,0xf0,0,
				0x0f,0x00,0x00,0x0f,0,
				0x0f,0x00,0x00,0x0f,0,
				0x00,0xff,0xff,0xf0,0,
				0x00,0x00,0x0f,0x00,0,
				0x00,0x00,0xf0,0x00,0,
				0x00,0x0f,0x00,0x00,0 };





/* *************************************************************************** */
/*	character, number & message generation routines */
/* *************************************************************************** */

		
write_num(chr,pos,ypos)
int	chr, pos;
{	/* write small numbers at ypos */

#ifdef	DEBUG
	if(pos<0 || pos>39) {
		cprintf(" error during write_num  pos=   %d   %d   %d   %d ",pos,test1,test2,test3);
		kb_rst(); exit(1);
	}
#endif 		


	switch(chr) {
	case 1:
		putf(pos*4,ypos,chr_1);
		break;

	case 2:
		putf(pos*4,ypos,chr_2);
		break;

	case 3:
		putf(pos*4,ypos,chr_3);
		break;

	case 4:
		putf(pos*4,ypos,chr_4);
		break;

	case 5:
		putf(pos*4,ypos,chr_5);
		break;

	case 6:
		putf(pos*4,ypos,chr_6);
		break;

	case 7:
		putf(pos*4,ypos,chr_7);
		break;

	case 8:
		putf(pos*4,ypos,chr_8);
		break;

	case 9:
		putf(pos*4,ypos,chr_9);
		break;

	case 0:
		putf(pos*4,ypos,chr_0);
		break;

	default:
#ifdef	DEBUG
	cprintf("error in switch tx - write_num \n\r ");
#endif
		break;
	}
	
}


		
write_char(chr,pos_x,pos_y)
int	chr, pos_x, pos_y;
{	/* write large text character on screen */

#ifdef	DEBUG
	if(pos_x<0 || pos_x>159 || pos_y<0 || pos_y>90) {
		cprintf(" error during write_char  pos=   %d   %d   %d   %d   %d ",pos_x,pos_y,test1,test2,test3);
		kb_rst(); exit(1);
	}
#endif 		


	switch(chr) {
	case 'A':
		putf(pos_x,pos_y,char_a);
		break;

	case 'B':
		putf(pos_x,pos_y,char_b);
		break;

	case 'C':
		putf(pos_x,pos_y,char_c);
		break;

	case 'D':
		putf(pos_x,pos_y,char_d);
		break;

	case 'E':
		putf(pos_x,pos_y,char_e);
		break;

	case 'F':
		putf(pos_x,pos_y,char_f);
		break;

	case 'G':
		putf(pos_x,pos_y,char_g);
		break;

	case 'H':
		putf(pos_x,pos_y,char_h);
		break;

	case 'I':
		putf(pos_x,pos_y,char_i);
		break;

	case 'J':
		putf(pos_x,pos_y,char_j);
		break;

	case 'K':
		putf(pos_x,pos_y,char_k);
		break;

	case 'L':
		putf(pos_x,pos_y,char_l);
		break;

	case 'M':
		putf(pos_x,pos_y,char_m);
		break;

	case 'N':
		putf(pos_x,pos_y,char_n);
		break;

	case 'O':
		putf(pos_x,pos_y,char_o);
		break;

	case 'P':
		putf(pos_x,pos_y,char_p);
		break;

	case 'Q':
		putf(pos_x,pos_y,char_q);
		break;

	case 'R':
		putf(pos_x,pos_y,char_r);
		break;

	case 'S':
		putf(pos_x,pos_y,char_s);
		break;

	case 'T':
		putf(pos_x,pos_y,char_t);
		break;

	case 'U':
		putf(pos_x,pos_y,char_u);
		break;

	case 'V':
		putf(pos_x,pos_y,char_v);
		break;

	case 'W':
		putf(pos_x,pos_y,char_w);
		break;

	case 'X':
		putf(pos_x,pos_y,char_x);
		break;

	case 'Y':
		putf(pos_x,pos_y,char_y);
		break;

	case 'Z':
		putf(pos_x,pos_y,char_z);
		break;

	case ' ':
		putf(pos_x,pos_y,char_space);
		break;

	case '.':
		putf(pos_x,pos_y,char_dot);
		break;

	case '_':
		putf(pos_x,pos_y,char_bar);
		break;

	case '0':
		putf(pos_x,pos_y,char_0);
		break;

	case '1':
		putf(pos_x,pos_y,char_1);
		break;

	case '2':
		putf(pos_x,pos_y,char_2);
		break;

	case '3':
		putf(pos_x,pos_y,char_3);
		break;

	case '4':
		putf(pos_x,pos_y,char_4);
		break;

	case '5':
		putf(pos_x,pos_y,char_5);
		break;

	case '6':
		putf(pos_x,pos_y,char_6);
		break;

	case '7':
		putf(pos_x,pos_y,char_7);
		break;

	case '8':
		putf(pos_x,pos_y,char_8);
		break;

	case '9':
		putf(pos_x,pos_y,char_9);
		break;


	default:
#ifdef	DEBUG
	cprintf("error in switch tx - write_char \n\r ");
#endif
		break;
	}
	
}


/*	Not used
write_high_score()
{	/* write HI SCORE in small letters at the top of screen */
	putf(90,2,text_high_score);

}
*/

write_text(text_string,pos_x,pos_y)
char	text_string[];
int	pos_x, pos_y;
{	/* write a text string to the screen using large letters */
	int	loop;

	loop=0;

	while(text_string[loop] !='\0') {
		write_char(text_string[loop],pos_x+10*loop,pos_y);
		loop++;
	}

}


/*	Not used
scroll_message(text)	/* rotate text string across top of screen */
char	text[];
{
	int	loop, pos_x, offset;
	char	tstr[20];

	offset=0;
	init_smsg();
	while(text[offset]!='\0') {
		for(loop=0; loop<5; loop++) {
			line(0,0,0,8,BLACK);
			line(1,0,1,8,BLACK);
			rrltop();
			chk_smsg();
			sleep(5);
			chk_smsg();
			sleep(5);
			chk_smsg();
			sleep(5);
			chk_smsg();
		}
		write_char(text[offset],150,1);
		offset++;
		chk_smsg();
	}
	init_smsg();

}
*/



/* *************************************************************************** */
/*	character, number & message color change routines */
/* *************************************************************************** */


flash_game_over(color)
{	/* change color of letters in GAME OVER for a twinkle effect */
text_change(char_g,((color+1)%6)+9);
text_change(char_a,((color+2)%6)+9);
text_change(char_m,((color+3)%6)+9);
text_change(char_o,((color+4)%6)+9);
text_change(char_v,((color+5)%6)+9);
text_change(char_e,((color+1)%6)+9);
text_change(char_r,((color+2)%6)+9);

}



text_color(color)
{	/* change color of all large text characters */

text_change(char_a,color);
text_change(char_b,color);
text_change(char_c,color);
text_change(char_d,color);
text_change(char_e,color);
text_change(char_f,color);
text_change(char_g,color);
text_change(char_h,color);
text_change(char_i,color);
text_change(char_j,color);
text_change(char_k,color);
text_change(char_l,color);
text_change(char_m,color);
text_change(char_n,color);
text_change(char_o,color);
text_change(char_p,color);
text_change(char_q,color);
text_change(char_r,color);
text_change(char_s,color);
text_change(char_t,color);
text_change(char_u,color);
text_change(char_v,color);
text_change(char_w,color);
text_change(char_x,color);
text_change(char_y,color);
text_change(char_z,color);

}



text_change(array_name,color)
char	array_name[];
int	color;
{	/* change color of a large text character but NOT numbers */

	int	loop, low_nib, high_nib;

	low_nib=color; high_nib=low_nib<<4;

	for(loop=2; loop<37; loop++) {

		if(array_name[loop] & 0xf) {	/* change low nibble */
			array_name[loop]=array_name[loop] & 0xf0;	/* mask of low nibble */
			array_name[loop]=array_name[loop] | low_nib;	/* set new low nibble */
		}

		if(array_name[loop] & 0xf0) {	/* change high nibble */
			array_name[loop]=array_name[loop] & 0x0f;	/* mask of high nibble */
			array_name[loop]=array_name[loop] | high_nib;	/* set new high nibble */
		}
                                      
	}

}





txt_color(color)
{	/* change color of all small text number */

txt_change(chr_0,color);
txt_change(chr_1,color);
txt_change(chr_2,color);
txt_change(chr_3,color);
txt_change(chr_4,color);
txt_change(chr_5,color);
txt_change(chr_6,color);
txt_change(chr_7,color);
txt_change(chr_8,color);
txt_change(chr_9,color);

}




txt_change(array_name,color)
char	array_name[];
int	color;
{	/* change color of a small text number */
	int	loop, low_nib, high_nib;

	low_nib=color; high_nib=low_nib<<4;

	for(loop=2; loop<12; loop++) {

		if(array_name[loop] & 0xf) {	/* change low nibble */
			array_name[loop]=array_name[loop] & 0xf0;	/* mask of low nibble */
			array_name[loop]=array_name[loop] | low_nib;	/* set new low nibble */
		}

		if(array_name[loop] & 0xf0) {	/* change high nibble */
			array_name[loop]=array_name[loop] & 0x0f;	/* mask of high nibble */
			array_name[loop]=array_name[loop] | high_nib;	/* set new high nibble */
		}
                                      
	}

}



/* *************************************************************************** */
/*	scan code to ascii & ascii to number convertions */
/* *************************************************************************** */

getval(chr)
char	chr;
{

	switch(chr) {
	case '1':
		return(1);
	case '2':
		return(2);
	case '3':
		return(3);
	case '4':
		return(4);
	case '5':
		return(5);
	case '6':
		return(6);
	case '7':
		return(7);
	case '8':
		return(8);
	case '9':
		return(9);
	default:
		return(0);
	}

}



conkey(chr)
char	chr;
{	/* convert the key scan code to the ascii equivelent */

	switch(chr) {
	case 0x1e:
		return('A');
	case 0x30:
		return('B');
	case 0x2e:
		return('C');
	case 0x20:
		return('D');
	case 0x12:
		return('E');
	case 0x21:
		return('F');
	case 0x22:
		return('G');
	case 0x23:
		return('H');
	case 0x17:
		return('I');
	case 0x24:
		return('J');
	case 0x25:
		return('K');
	case 0x26:
		return('L');
	case 0x32:
		return('M');
	case 0x31:
		return('N');
	case 0x18:
		return('O');
	case 0x19:
		return('P');
	case 0x10:
		return('Q');
	case 0x13:
		return('R');
	case 0x1f:
		return('S');
	case 0x14:
		return('T');
	case 0x16:
		return('U');
	case 0x2f:
		return('V');
	case 0x11:
		return('W');
	case 0x2d:
		return('X');
	case 0x15:
		return('Y');
	case 0x2c:
		return('Z');

	case 0x34:
		return('.');
	case 0x39:
		return(' ');

	case 0x0b:
		return('0');
	case 0x02:
		return('1');
	case 0x03:
		return('2');
	case 0x04:
		return('3');
	case 0x05:
		return('4');
	case 0x06:
		return('5');
	case 0x07:
		return('6');
	case 0x08:
		return('7');
	case 0x09:
		return('8');
	case 0x0a:
		return('9');

	default:
		return(0);
	}
}



/* *************************************************************************** */
/*	screen printing routines */
/* *************************************************************************** */



crlf()	/* send a cr - lf sequence to the console */
{
	ttywrt(0x0a);
	ttywrt(0x0d);

}

col_print(string, color)	/* print the string on the console */
char	string[];
int	color;
{
	int	loop, c;

	loop=0;

	while(string[loop]!=0) {
		c=string[loop];
		ttywrt(c,color);
		loop++;
	}
	crlf();

}


