
/*
*****************************************************************************************************
*****************************************************************************************************
*****                                                                                           *****
*****                  Task E   -   Keyboard and Joystick interfacing routines                 *****
*****                                                                                           *****
*****************************************************************************************************
*****************************************************************************************************
*/

#include	"styx.h"

int	last_key, joy_x_low, joy_y_low, joy_x_high, joy_y_high, joyuse, button;


init_joy()	/* Initialize joysticks */
{
	int	a, loop;

	keydir=99;
	lkdir=99;
	button=FALSE;

	joyuse=TRUE;	/* check if a joystick is atached */
	for(loop=0; loop<10; loop++) {	/* check 10 times in case of false noise */
		outp(0x201,0);
		if(!(inp(0x201) & 3))	/* check that timer is not already finished */
			joyuse=FALSE;

		a=0;	/* check that timer times out below limit */
		while((inp(0x201)& 3) && a<255)
			a++;
		if(a>250)
			joyuse=FALSE;

	}

}



joystk()
{	/* update variables related to joystick, buttons & keyboard */

	last_key=lkdir;
	if(keydir<99)
		last_key=keydir;

	lkdir=99;

	if(fire)	/* reset button of keyboard F1 is not pressed */
		button=TRUE;
	else
		button=FALSE;

	if(joyuse) {
		chkjoy();	/* update joystick & button status */
		if(butt1)	/* update button variable for internal use */
			button=TRUE;
		else
			button=FALSE;
	}

}


start_wait()	/* wait for the joystick button or a key to be pressed */
{		/* the joystick MUST be in the centre position at this time */
	int	a;

/*	if(joyuse)
		cprintf("press button #1 to start \n\r");
	else
		cprintf(" Press any key to begin \n\r");
*/

	a=TRUE;	/* wait for a key or joystick button to be pressed */
	while(a) {
		if(joyuse) {
			chkjoy();
			if(butt1)
				a=FALSE;
		}
		if(keychr!=0 && !(keychr&0x80)) {
			a=FALSE;
			joyuse=FALSE;
			keychr=0;

		}
	}

	if(joyuse) {
		chkjoy();	/* update joystick values */
		joy_x_low=joyx-30;
		if(joy_x_low<0)
			joy_x_low=0;
		joy_x_low+=5;

		joy_y_low=joyy-30;
		if(joy_y_low<0)
			joy_y_low=0;
		joy_y_low+=5;

		joy_x_high=joyx+30;
		if(joy_x_high>255)
			joy_x_high=255;
		joy_x_high-=5;

		joy_y_high=joyy+30;
		if(joy_y_high>255)
			joy_y_high=255;
		joy_y_high-=5;

	}


}



check_turn()
{	/* get direction from keyboard or joystick */
	int	a;

	a=last_key;

	if(joyuse) {

		a=99;

		if(joyx<joy_x_low) {
			a=4;
			if(joyy<joy_y_low)
				a=3;
			if(joyy>joy_y_high)
				a=5;
		}

		if(joyx>joy_x_high){
			a=0;
			if(joyy<joy_y_low)
				a=1;
			if(joyy>joy_y_high)
				a=7;
		}
		if(joyx>=joy_x_low && joyx<=joy_x_high) {
			if(joyy<joy_y_low)
				a=2;
			if(joyy>joy_y_high)
				a=6;
		}

	}

	return(a);	/* return direction value */
	
}
		


get_button()	/* return the button status */
{
	return(button);

}

